module Pod
  class Command
    class Jysource
      # This is an example of a cocoapods plugin adding a top-level subcommand
      # to the 'pod' command.
      #
      # You can also create subcommands of existing or new commands. Say you
      # wanted to add a subcommand to `list` to show newly deprecated pods,
      # (e.g. `pod list deprecated`), there are a few things that would need
      # to change.
      #
      # - move this file to `lib/pod/command/list/deprecated.rb` and update
      #   the class to exist in the the Pod::Command::List namespace
      # - change this class to extend from `List` instead of `Command`. This
      #   tells the plugin system that it is a subcommand of `list`.
      # - edit `lib/cocoapods_plugins.rb` to require this file
      #
      # @todo Create a PR to add your plugin to CocoaPods/cocoapods.org
      #       in the `plugins.json` file, once your plugin is released.
      #
      class Path < Jysource
        self.summary = '源码路径,         使用: pod jysource path'

        self.description = <<-DESC
          打印源码下载的路径
        DESC

        def self.options
          [[
            '--clean', 'just path'
          ]].concat(super)
        end

        def initialize(argv)
          @linked = argv.flag?('clean')
          super
        end

        self.arguments = []

        def validate!
          super
        end

        def run
          target_path = '/Users/Shared/JYSource/Pods'
          if @linked then
            puts "#{target_path}"
          else
            UI.puts "\033[33m已下载源码位置:\033[0m\n"
            puts "#{target_path}" + "#{@linked}" 
          end
        end

      end
    end
  end
end
